
import java.sql.*;
import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;


public class MessageService extends HttpServlet {

    private Connection connection;
    final private String dbms_url = "jdbc:mysql://127.0.0.1:3306/";
    final private String database = "Messaggi";
    final private String user = "root";
    final private String password = "";
    final private String driver = "com.mysql.jdbc.Driver";
    private boolean connected;

    public void init() {
        System.out.println("INIT");
        String url = dbms_url+database;
        try {
            Class.forName(driver);
            connection = DriverManager.getConnection(url, user, password);
            connected = true;
        }
        catch (SQLException e) {
            connected = false;
        }
        catch (ClassNotFoundException e) {
            connected = false;
        }
    }
    
    public void destroy() {
        System.out.println("DESTROY");
        try {
            connection.close();
        }
        catch (SQLException e) {
        }
    }
    
    protected void doGet(HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        PrintWriter out;
        Statement stat;
        ResultSet result;
        String[] url_section;
        String timestamp;
        String url = request.getRequestURL().toString();
                
        if (!connected) {
            response.sendError(500, "DBMS server error!");
            return;
        }
        if (url.endsWith("/")) {
            try {
                stat = connection.createStatement();
                result = stat.executeQuery("SELECT timestamp, testo FROM Messaggi;");
                response.setContentType("text/xml;charset=UTF-8");
                out = response.getWriter();
                out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                out.println("<message-list>");
                while (result.next()) {
                    out.println("<message>");
                    out.println("<timestamp>" + result.getString(1) + "</timestamp>");
                    out.println("<text>" + result.getString(2) + "</text>");
                    out.println("</message>");
                }
                out.println("</message-list>");
                result.close();
                stat.close();
                out.close();
                response.setStatus(200); // OK
            }
            catch (SQLException e) {
                response.sendError(500, "DBMS server error!");
            }
        }
        else {
            url_section = url.split("/");
            timestamp = url_section[url_section.length-1];
            try {
                stat = connection.createStatement();
                result = stat.executeQuery("SELECT timestamp, testo FROM Messaggi WHERE timestamp = " + timestamp + ";");
                response.setContentType("text/xml;charset=UTF-8");
                if (result.first()) {
                    out = response.getWriter();
                    out.println("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                    out.println("<message>");
                    out.println("<timestamp>" + result.getString(1) + "</timestamp>");
                    out.println("<text>" + result.getString(2) + "</text>");
                    out.println("</message>");
                    result.close();
                    stat.close();
                    out.close();
                    response.setStatus(200); // OK
                }
                else {
                    response.sendError(404, "Message with given timestamp nor found!");
                }
            }
            catch (SQLException e) {
                response.sendError(500, "DBMS server error!");
            }

        }
    }
    
    protected void doPost (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String text;
        Timestamp now = new Timestamp(System.currentTimeMillis());
        long timestamp = now.getTime();

        if (!connected) {
            response.sendError(500, "DBMS server error!");
            return;
        }
        text = request.getParameter("text");
        if (text == null) {
            response.sendError(400, "Request syntax error!");
            return;
        }
        if (text.isEmpty()) {
            response.sendError(400, "Request syntax error!");
            return;
        }
        try {
            Statement statement = connection.createStatement();
            if (statement.executeUpdate("INSERT Messaggi(timestamp, testo) VALUES(" + timestamp + ", '" + text + "');") <= 0) {
                response.sendError(403, "Duplicated timestamp!");
                statement.close();
                return;
            }
            statement.close();
        }
        catch (SQLException e) {
            response.sendError(500, "DBMS server error!");
            return;
        }
        response.setStatus(201); // OK
    }
    
    protected void doDelete (HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
        String timestamp;
        String url = request.getRequestURL().toString();
        String[] url_section;
        
        if (!connected) {
            response.sendError(500, "DBMS server error!");
            return;
        }
        if (url.endsWith("/")) {
            response.sendError(404, "Request syntax error!");
            return;
        }
        url_section = url.split("/");
        timestamp = url_section[url_section.length-1];
        if (timestamp == null) {
            response.sendError(400, "Request syntax error!");
            return;
        }
        if (timestamp.isEmpty()) {
            response.sendError(400, "Request syntax error!");
            return;
        }
        try {
            Statement statement = connection.createStatement();
            if (statement.executeUpdate("DELETE FROM Messaggi WHERE timestamp = " + timestamp + ";") <= 0) {
                response.sendError(404, "Message with given timestamp nor found!");
                statement.close();
                return;
            }
            statement.close();
        }
        catch (SQLException e) {
            response.sendError(500, "DBMS server error!");
            return;
        }
        response.setStatus(200); // OK
    }
    
    public String getServletInfo() {
        return "Text message service";
    }
}
