
package it.zanichelli.jerseycalculator;

import javax.ws.rs.core.*;
import javax.ws.rs.*;

/**
 * REST Web Service
 *
 * @author Giorgio
 */

@ApplicationPath("/")
@Path("/calculator")
public class JerseyCalculator extends Application {
    public JerseyCalculator() {
        super();
    }

    @GET
    @Produces("text/xml")
    @Path("/{operation}")
    public String getResult(@PathParam(value="operation") String operation,
                            @QueryParam("X") double x, @QueryParam("Y") double y) {
        double r;
        if (operation.equalsIgnoreCase("ADD")) r = x + y;
        else if (operation.equalsIgnoreCase("SUB")) r = x - y;
        else if (operation.equalsIgnoreCase("MUL")) r = x * y;
        else if (operation.equalsIgnoreCase("DIV")) {
               if (y != 0.0) r = x / y;
               else throw new WebApplicationException("Division by zero!", 400);
              }
        else throw new WebApplicationException("Wrong operation!", 400);
        return ("<result>" + Double.toString(r) + "</result>");
    }
}
